#!/bin/sh
# Proportional HP-Kanji Font Ver 1.2
#
MAKEFILE="Makefile"

BDFTOPCF="/usr/bin/X11/bdftopcf"
MKFONTDIR="/usr/bin/X11/mkfontdir"

DEFAULT_SRCFONTROOT="../bdf"
DEFAULT_DESTFONTDIR="/usr/local/lib/X11/fonts/hp_japanese"

echo ""
echo "Where is BDF fonts directory?"
echo " [$DEFAULT_SRCFONTROOT]: \c"
read ans
if [ "$ans" = "" ]
then
	ans=$DEFAULT_SRCFONTROOT
fi
SRCFONTROOT=$ans
echo

echo "Where do you want to install new fonts?"
echo " [$DEFAULT_DESTFONTDIR]: \c"
read ans
if [ "$ans" = "" ]
then
	ans=$DEFAULT_DESTFONTDIR
fi
DESTFONTDIR=$ans
echo

echo "Do you use bold kanji fonts? ([y]/n): \c"
read ans
if [ "$ans" = "" -o "$ans" = "y" -o "$ans" = "Y" ]
then
	MAKEBOLDKANJI="Yes"
else
	MAKEBOLDKANJI="No"
fi
echo

echo "Your setup parameters are ..."
echo ""
echo "BDF fonts directory  = \"$SRCFONTROOT\""
echo "Install directory    = \"$DESTFONTDIR\""
echo "Use bold kanji fonts = $MAKEBOLDKANJI"
echo ""
echo "Is it OK? ([y]/n): \c"
read ans
if [ "$ans" != "" -a "$ans" != "y" -a "$ans" != "Y" ]
then
	exit 1
fi
echo

echo "Now, making $MAKEFILE..."

ALLENCODING="jpn jeuc"
ALLFONT="12 14 16 18 24 32"
FONT75="12 14 18 24"
FONT100="16 32"
TIMES="timR timB timI timBI"
COURIER="courR courB courO courBO"
HELVETICA="helvR helvB helvO helvBO"
ALLFAMILY="$TIMES $COURIER $HELVETICA"

R12="\"-bridge-gothic-medium-r-normal--12-120-75-75-c-120-jisx0208.1983-0\""
R14="\"-misc-fixed-medium-r-normal--14-130-75-75-c-140-jisx0208.1983-0\""
R16="\"-bridge-gothic-medium-r-normal--18-180-75-75-c-160-jisx0208.1983-0\""
R18="\"-jis-fixed-medium-r-normal--16-150-75-75-c-160-jisx0208.1983-0\""
R24="\"-jis-fixed-medium-r-normal--24-230-75-75-c-240-jisx0208.1983-0\""
R32="\"-hp-mincho-medium-r-normal--32-320-75-75-c-320-jisx0208.1983-0\""
B16="\"-hp-newgothic-bold-r-normal--18-180-75-75-c-160-jisx0208.1983-0\""
B18="\"-hp-gothic-bold-r-normal--18-180-75-75-c-160-jisx0208.1983-0\""

cp /dev/null "$MAKEFILE"
echo "SRCFONTROOT = $SRCFONTROOT"		>> $MAKEFILE
echo "DESTFONTDIR = $DESTFONTDIR"		>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "BDFTOPCF = $BDFTOPCF"			>> $MAKEFILE
echo "MKFONTDIR = $MKFONTDIR"			>> $MAKEFILE
echo "MAKEJPNFONT = ../makejpnfont.sh"		>> $MAKEFILE
echo "DPICONV = ../dpiconv.sh"			>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "SRCFONTDIR = \$(SRCFONTROOT)/75dpi"	>> $MAKEFILE
echo "ALTSRCFONTDIR = \$(SRCFONTROOT)/100dpi"	>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "timR12 = $R12"				>> $MAKEFILE
echo "timR14 = $R14"				>> $MAKEFILE
echo "timR16 = $R16"				>> $MAKEFILE
echo "timR18 = $R18"				>> $MAKEFILE
echo "timR24 = $R24"				>> $MAKEFILE
echo "timR32 = $R32"				>> $MAKEFILE
echo "timB12 = \$(timR12)"			>> $MAKEFILE
echo "timB14 = \$(timR14)"			>> $MAKEFILE
if [ $MAKEBOLDKANJI = "Yes" ]
then
	echo "timB16 = $B16"			>> $MAKEFILE
	echo "timB18 = $B18"			>> $MAKEFILE
else
	echo "timB16 = \$(timR16)"		>> $MAKEFILE
	echo "timB18 = \$(timR18)"		>> $MAKEFILE
fi
echo "timB24 = \$(timR24)"			>> $MAKEFILE
echo "timB32 = \$(timR32)"			>> $MAKEFILE
echo ""						>> $MAKEFILE

for DOT in $ALLFONT
do
	echo "timI${DOT} = \$(timR${DOT})"	>> $MAKEFILE
	echo "timBI${DOT} = \$(timB${DOT})"	>> $MAKEFILE

	echo "courR${DOT} = \$(timR${DOT})"	>> $MAKEFILE
	echo "courB${DOT} = \$(timB${DOT})"	>> $MAKEFILE
	echo "courO${DOT} = \$(courR${DOT})"	>> $MAKEFILE
	echo "courBO${DOT} = \$(courB${DOT})"	>> $MAKEFILE

	echo "helvR${DOT} = \$(timR${DOT})"	>> $MAKEFILE
	echo "helvB${DOT} = \$(timB${DOT})"	>> $MAKEFILE
	echo "helvO${DOT} = \$(helvR${DOT})"	>> $MAKEFILE
	echo "helvBO${DOT} = \$(helvB${DOT})"	>> $MAKEFILE
done
echo ""						>> $MAKEFILE

echo "OBJS75 = \c"				>> $MAKEFILE
for ENCODING in $ALLENCODING
do
	for FAMILY in $ALLFAMILY
	do
		echo "\\"			>> $MAKEFILE
		echo " \c"			>> $MAKEFILE
		for DOT in $FONT75
		do
			echo "${ENCODING}.${FAMILY}${DOT}.pcf \c">> $MAKEFILE
		done
	done
done
echo "\n"					>> $MAKEFILE

echo "OBJS100 = \c"				>> $MAKEFILE
for ENCODING in $ALLENCODING
do
	for FAMILY in $ALLFAMILY
	do
		echo "\\"			>> $MAKEFILE
		echo " \c"			>> $MAKEFILE
		for DOT in $FONT100
		do
			echo "${ENCODING}.${FAMILY}${DOT}.pcf \c">> $MAKEFILE
		done
	done
done
echo "\n"					>> $MAKEFILE

echo "OBJS = \$(OBJS75) \$(OBJS100)"		>> $MAKEFILE
echo ""						>> $MAKEFILE
echo ".SUFFIXES: .bdf .pcf"			>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "all:: \$(OBJS) fonts.dir fonts.alias"	>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "fonts.dir: \$(OBJS)"			>> $MAKEFILE
echo "	\$(MKFONTDIR) ."			>> $MAKEFILE
echo ""						>> $MAKEFILE
echo "fonts.alias: fonts.dir"			>> $MAKEFILE
echo "	echo \\\"\"FILE_NAMES_ALIASES\\\"\" > fonts.alias"	>> $MAKEFILE
echo ""						>> $MAKEFILE
echo ".bdf.pcf:"				>> $MAKEFILE
echo "	\$(BDFTOPCF) \$? -o \$@"		>> $MAKEFILE
echo ""						>> $MAKEFILE

for ENCODING in $ALLENCODING
do
	for FAMILY in $ALLFAMILY
	do
		for DOT in $FONT75
		do
			echo "${ENCODING}.${FAMILY}${DOT}.bdf: \$(SRCFONTDIR)/${FAMILY}${DOT}.bdf"	>> $MAKEFILE
			echo "	\$(MAKEJPNFONT) \$(${FAMILY}${DOT}) ${ENCODING} < \$? > \$@"	>> $MAKEFILE
			echo ""	>> $MAKEFILE
		done
		for DOT in $FONT100
		do
			SUBDOT=`expr $DOT / 4 \* 3`
			echo "${ENCODING}.${FAMILY}${DOT}.bdf: \$(ALTSRCFONTDIR)/${FAMILY}${SUBDOT}.bdf"	>> $MAKEFILE
			echo "	\$(DPICONV) < \$? | \$(MAKEJPNFONT) \$(${FAMILY}${DOT}) ${ENCODING} > \$@"	>> $MAKEFILE
			echo ""	>> $MAKEFILE
		done
	done
done

echo "install:: \$(OBJS) fonts.dir fonts.alias"			>> $MAKEFILE
echo "	cp \$(OBJS) fonts.dir fonts.alias \$(DESTFONTDIR)"	>> $MAKEFILE
echo ""								>> $MAKEFILE
echo "clean::"							>> $MAKEFILE
echo "	rm *.pcf *.bdf fonts.dir fonts.alias"			>> $MAKEFILE

echo "Complete."
echo ""
echo "Please run \"make install\"."

exit 0
