#!/bin/sh
ASSOCIATE_FONT="$1"
LANGUAGE="japanese"
ENCODING="Japanese15"
if [ "$2" = "jeuc" ]
then
	LANGUAGE="japanese.euc"
	ENCODING="JapaneseEUC"
fi
awk -v ASSOCIATE_FONT=$ASSOCIATE_FONT -v LANGUAGE=$LANGUAGE -v ENCODING=$ENCODING '
{
	if ($1 == "FONT") {
		if (split($2, f, "-") != 15)
			exit(1)
		printf("FONT %s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-HP-%s\n",
			f[1], f[2], f[3], f[4], f[5], f[6], f[7],
			f[8], f[9], f[10], f[11], f[12], f[13], ENCODING)
	} else if ($1 == "STARTPROPERTIES") {
		print "STARTPROPERTIES", $2 + 2
	} else if ($1 == "CHARSET_REGISTRY") {
		print "CHARSET_REGISTRY \"HP\""
	} else if ($1 == "CHARSET_ENCODING") {
		print "CHARSET_ENCODING \"" ENCODING "\""
	} else if ($1 == "ENDPROPERTIES") {
		print "LANGUAGE \"" LANGUAGE "\""
		print "ASSOCIATE_FONT \"" ASSOCIATE_FONT "\""
		print "ENDPROPERTIES"
	} else {
		print
	}
}'
